<?php
//ini_set('error_reporting', E_ALL | E_STRICT);
//ini_set('display_errors', true);


#######################################
#                                     #
#   ~~Gästebuch                       #
#           Version: 4.0~~            #
#                                     #
#   Um das Gästebuch einbinden und    #
#   anpassen zu können, lesen Sie     #
#   bitte die Beschreibung!           #
#                                     #
#######################################

//Der Rest kann über den Adminbereich - Config eingestellt werden!

//Pfad zum Gästebuch Ordner
$GLOBALS['folderPath'] = './';

// Admin - Logindaten
define('ADMIN_NAME', 'Admin');
define('ADMIN_PW', sha1('1224'));

//URL-Name der Datei
define('SELF', 'gaestebuch.php');

//Speicherdateien
define('DB_FILE', 'db.dat');
define('IP_FILE', 'ip.dat');


/* 
#######################
#                     #
#   Lizenzbedingung   #
#                     #
#######################
Das Material des Gästebuchs steht unter der Creative-Commons-Lizenz Namensnennung 
- Weitergabe unter gleichen Bedingungen 3.0 Deutschland.
Um eine Kopie dieser Lizenz zu sehen, besuchen Sie http://creativecommons.org/licenses/by-sa/3.0/de/.
Das ursprüngliche Werk stammt von http://suchdichsatt.de/tutorial/php-gaestebuch.

Ausgenommen von dieser Lizenz ist der Captcha Ordner und die Smilies.
Die Smilies dürfen ohne Zustimmung der Betreiber von suchdichsatt.de 
nicht weitergegeben oder in einem anderen Script verwenden werden!


~~~~~~~~~~~~~~~ Changelog ~~~~~~~~~~~~~~~
Created by Dennis & Philipp Schweinbenz
--> http://suchdichsatt.de

# Version 1.0 - fertiggestellt am 20.09.2010:
- Adminbereich: Einträge löschen / Ip des Benutzers ansehen
- Neues Design
- Rechencaptcha und Zahlencaptcha
- Email Benachrichtigung

~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

# Version 2.0 - fertiggestellt am 15.10.2010:
- Adminbereich: Einträge ändern
- Neues Design des Admins (Farbe des Namens)
- Neuer Bbccode: Smilies, Nachrichten fett, kursiv oder unterstrichen markieren
- XHTML ready
- Spamabfang über ein unsichtbares Input Feld
- Nachrichtenzähler (#1 #2 ...)

~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

# Version 3.0 - fertiggestellt am 05.11.2010:
- Linksperre gefixed und ausgebaut
- Keine Ip Sperre mehr für Admins
- bessere Ip Sperre durch Cookies & Sessions
- Badword Filter
- neues, normales Captcha
- neues Rechencaptcha
- Versionskontrolle, automatische Erkennung bei alter Version

~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

# Version 3.1 - fertiggestellt am 24.11.2010:
- kleine Änderung beim Badwort Filter
- besseren Bbccode (man kann jetzt auch Links eingeben)
- geschützter Adminbereich (3 Fehlversuche = Sperre durch Session und Cookie)
- Fehlermeldung kann nun selbst erstellt werden (config.php)

~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

# Version 4.0 - fertiggestellt am 30.08.2014:
- Kompletter Rewrite des Gästebuchs
  -> Unnötigen/Fehlerhaften Code entfernt
  -> Neue Speicherstruktur, klevere Algorithmen
- Standard Style aufgepeppt
- Entfernung des Rechencaptchas, Verbesserung des normalen Captchas
- Adminbereich geschützt durch IP-Log & Fehlversuchsperrung
- Config Datei hinzugefügt
- Sicherheit der Sessions erhöht


# Version 4.1
# In Planung
- Vorschläge von Usern

~~~~~~~~~~~~~~~ Changelog ~~~~~~~~~~~~~~~
*/

require_once ($GLOBALS['folderPath'] . 'config.php');
require_once (FOLDERPATH . 'function.php');
gb_sec_session_start();

require_once (FOLDERPATH . 'style.php');

####################
# Nicht editieren! #
####################
if (FUNC === 'config' && isset($_POST['submit']) && $_POST['submit'] === 'Speichern') {
	$data = array (
		'Setting' => array (
			'color' 			=> '#' . $_POST['color'],
			'post_time' 		=> $_POST['post_time'],
			'dateformat' 		=> $_POST['dateformat'],
			'email' 			=> $_POST['email'],
			'notification' 		=> $_POST['notification'],
			'bbccode' 			=> $_POST['bbccode'],
			'smilies' 			=> $_POST['smilies'],
			'captcha' 			=> $_POST['captcha'],
			'badword_filter' 	=> $_POST['badword_filter'],
			'badwords' 			=> $_POST['badwords'],
			'min_name' 			=> $_POST['min_name'],
			'max_name' 			=> $_POST['max_name'],
			'min_message' 		=> $_POST['min_message'],
			'max_message' 		=> $_POST['max_message'],
			'max_url' 			=> $_POST['max_url'],
			'ip_ban_message' 	=> $_POST['ip_ban_message'],
			'db_error_message' 	=> $_POST['db_error_message']
	));
	write_ini_file($data, FOLDERPATH . 'config.ini', true);
}

$ini_array = @parse_ini_file(FOLDERPATH . 'config.ini') or die('Es ist ein Fehler beim Aufrufen der config.ini aufgetreten');
$GLOBALS['color'] = $ini_array['color'];
$GLOBALS['dateformat'] = $ini_array['dateformat'];
$GLOBALS['post_time'] = $ini_array['post_time'];
$GLOBALS['email'] = $ini_array['email'];
$GLOBALS['notification'] = $ini_array['notification'];
$GLOBALS['bbccode'] =  $ini_array['bbccode'];
$GLOBALS['smilies'] = $ini_array['smilies'];
$GLOBALS['captcha'] = $ini_array['captcha'];
$GLOBALS['badword_filter'] = $ini_array['badword_filter'];
$GLOBALS['badwords'] = explode(',', $ini_array['badwords']);
$GLOBALS['badwords_string'] = $ini_array['badwords'];
$GLOBALS['min_name'] = $ini_array['min_name'];
$GLOBALS['max_name'] = $ini_array['max_name'];
$GLOBALS['min_message'] = $ini_array['min_message'];
$GLOBALS['max_message'] = $ini_array['max_message'];
$GLOBALS['max_url'] = $ini_array['max_url'];
$GLOBALS['ip_ban_message'] = $ini_array['ip_ban_message'];
$GLOBALS['db_error_message'] = $ini_array['db_error_message'];

echo '<script type="text/javascript" src="' . $GLOBALS['folderPath'] . 'function.js"></script>';

$GLOBALS['gb_version'] = '4.0'; //Gästebuch Version - Wird benötigt, um eine neuere Version zu finden
##############
# Navigation #
##############
$output = '<div class="gbContainer" id="gaestebuch">
<p>
	<a href="' . SELF . '#gaestebuch">Kommentare anzeigen</a> - 
	<a href="' . SELF . '?func=message#gaestebuch">Nachricht erstellen</a> - 
	<a href="' . SELF . '?func=admin#gaestebuch">Admin</a>';
	 $output .= (gb_checkLogin()) ? ' - <a href="' . SELF . '?func=config#gaestebuch">Config</a> - <a href="' . SELF . '?func=logout#gaestebuch">Logout</a>' : '';
$output .= '</p><br />';
echo $output;

if (FUNC === 'logout') {
	echo '<p>Sie haben sich ausgeloggt!</p>'; 
	unset($_SESSION[SESSION_GB_LOGIN]); //Gesetzte Sessions zerstören
	unset($_SESSION[SESSION_GB_PW]);
	echo gb_redirect(SELF); //Weiterleitung
}

switch (FUNC) {
	###########
	# Ausgabe #
	###########
	default: func:
		if (!$fp = @fopen(DB_FILE, 'r')) { //Öffnen des Textfeldes/Datenbank; @ = Unterdrückung der Fehlermeldung
			echo errorOutput($GLOBALS['db_error_message']);
			break;
		}

		$i = count(file(DB_FILE));
		while (!feof($fp)) { //Prüft ob der Dateizeiger am Ende der Datei angekommen ist
			$data = fgets($fp, 4096); //Liest bis zur angegebenen Länge oder einem Zeilenumbruch
			if (empty($data)) break;
			list ($counter, $date, $sender, $ip, $name, $message) = str_replace('\|', '|', preg_split('/(?<!\\\)(\|)/', $data));
			
			if ($GLOBALS['smilies'] == 1) {
				$message = replaceSmilie($message);
			}
			if ($GLOBALS['bbccode'] == 1) {
				$message = replaceBbccode($message);
			}

			$dayArray = array('Sonntag', 'Montag', 'Dienstag', 'Mittwoch', 'Donnerstag', 'Freitag', 'Samstag');
			$dayNumber = date("w", $date); // Aktuellen Tag ermitteln
			$day = $dayArray[$dayNumber]; //Wochentag ermitteln

			if ($sender === 'a') {
				echo '<p style="color: ' . $GLOBALS['color'] . '; display: inline;"> ' . $name . ' <span style="float: right;">#' . $i . '</span><br /></p>
				<p>(' . $day . ', ' . date($GLOBALS['dateformat'], $date) . ')<br />' . $message . '<br /><br />
				' . gb_getLayout('hr') . '</p>';
			} elseif ($sender === 'b') {
				echo '<p style="display: inline;"> <b>' . $name . '</b> <span style="float: right;">#' . $i . '</span><br /></p>
				<p>(' . $day . ', ' . date($GLOBALS['dateformat'], $date) . ')<br />' . $message . '<br /><br />
				' . gb_getLayout('hr') . '</p>';
			}
			$i--;
		}
		fclose($fp);
	break;
	
	#######################
	# Nachricht erstellen #
	#######################
	case 'message':
		if (!gb_checkLogin()) {
			//Zeitsperre
			if (isset($_SESSION[SESSION_GB_SPAM]) && !empty($_SESSION[SESSION_GB_SPAM])) {
				if (time() > $_SESSION[SESSION_GB_SPAM] + $GLOBALS['post_time']) {
					unset($_SESSION[SESSION_GB_SPAM]);
				} else {
					echo errorOutput($GLOBALS['ip_ban_message']); //IP Check
					break;	
				}
			}
			
			if (!$fp = @fopen(DB_FILE, 'r')) { //Öffnen der Datenbank
				echo errorOutput($GLOBALS['db_error_message']);
				break;
			}
			
			$data = fgets($fp, 4096); //Liest bis zur angegebenen Länge oder einem Zeilenumbruch
			if ($data !== false) {
				list ( , $date, , $ip, , ) = str_replace('\|', '|', preg_split('/(?<!\\\)(\|)/', $data));

				if ($_SERVER['REMOTE_ADDR'] === $ip && time() < $date + $GLOBALS['post_time']) {
					echo errorOutput($GLOBALS['ip_ban_message']); //IP Check
					break;
				}
			}
			fclose($fp);
		}
		
		if (isset($_POST['submit']) && $_POST['submit'] === 'Absenden') { //Überprüfen, wenn submit Button gedrückt wird
			if (!isset($_POST['name']) || !isset($_POST['message']) || !isset($_POST['captcha']) || ($GLOBALS['captcha'] == 1 && !isset($_POST['captcha_eingabe']))) {
				echo errorOutput('Bitte alle Felder ausfüllen');
			} else {
				$name = gb_escapeStr($_POST['name']); //Eingabe des Users in eine Variable speichern
				$message = gb_escapeStr($_POST['message']);
				$hiddenField = gb_escapeStr($_POST['captcha']);
				if ($GLOBALS['captcha'] == 1)
					$captcha_input = gb_escapeStr($_POST['captcha_eingabe']);
				
				$name_len = gb_getWordLength($name); //Anzahl an Buchstaben des eingegebenen Namen
				$message_len = gb_getWordLength($message); //Anzahl an Buchstaben der eingegebenen message
				$ip_user = $_SERVER['REMOTE_ADDR'];
				
				$error = '';
				$now = time();
		
				if (isset($name) && $name_len <= 0) {
					$error .= '-Bitte geben Sie einen Namen ein!<br />';
				} else {
					if ($name_len > $GLOBALS['max_name']) { //message größer als Max.
						$error .= '-Ihr Name ist zu lang, es sind ' . $name_len . ' Buchstaben, <br />
									aber nur max. ' . $GLOBALS['max_name'] . ' erlaubt.<br />';
					} elseif ($name_len < $GLOBALS['min_name']) {
						$error .= '-Ihr Name ist zu kurz!  (Min: ' . $GLOBALS['min_name'] . ' Buchstaben)<br />';
					}
				}
		
				if (isset($message) && $message_len <= 0) {
					$error .= '-Bitte geben Sie eine Nachricht ein!<br />';
				} else {
					if ($message_len > $GLOBALS['max_message']) { //message größer als Max.
						$error .= '-Ihre message ist zu lang, es sind ' . $message_len . ' Buchstaben, <br />
									aber nur max. ' . $GLOBALS['max_message'] . ' erlaubt.<br />';
					// Wenn mehr Links als erlaubt, dann ...
					} elseif (substr_count($message, 'http://') + substr_count($message, 'https://') + substr_count($message, 'href') > $GLOBALS['max_url'] || 
							  substr_count($message, 'url') > $GLOBALS['max_url'] * 2) {
						$error .= '-Es sind nur max. ' . $GLOBALS['max_url'] . ' Links pro Beitrag erlaubt.<br />'; // Fehlermeldung ausgeben.
					} elseif ($message_len < $GLOBALS['min_message']) { // Betreff kleiner als Minimum
						$error .= '-Ihre message ist zu kurz!  (Min: ' . $GLOBALS['min_message'] . ' Buchstaben)<br />';  // Error Message
					}
				}
				
				if ($GLOBALS['captcha'] == 1) {
					if (!isset($captcha_input) || gb_getWordLength($captcha_input) <= 0) { // Überprüfung des Captchas-Code
						$error .= '-Bitte füllen Sie das Feld mit dem Captcha aus!<br />';
					} else {
						if (strtoupper($captcha_input) !== $_SESSION[SESSION_GB_CAPTCHA]) {
							$error .= '-Bitte geben Sie den richtigen Captcha-Code ein!<br />';
						}
					}
				}
		
				if ($hiddenField !== "") { //Wenn das Feld nicht leer ist --> Spambot, für User nicht unsichtbar!
					$error .= '-Spam Bot identifiziert!';
					$_SESSION[SESSION_GB_SPAM] = time() - 2*60*60; //Spambot für 2h sperren
					exit;
				} // Prüft, ob der Spambot das Feld ausfüllt, wenn ja --> Spam
	
				if ($error) { // Ausgabe der error message
					echo errorOutput($error);
				} else {
					if ($GLOBALS['badword_filter'] == 1) {
						foreach ($GLOBALS['badwords'] as $badword) {
							$str = gb_getWordLength($badword);
							$strb = $str - 2;
							$message = preg_replace('/' . trim($badword) . '/i', substr(trim($badword), 0, -$strb) . '**', $message);
						}
					}
					$_SESSION[SESSION_GB_SPAM] = time();
					
					$sender = 'b';
					if (gb_checkLogin()) // Überprüfen ob der Admin eingeloggt ist (mit sessions)
						$sender = 'a'; //Wenn ja Name beim Eintrag farbig schreiben
	
					
					$filesize = filesize(DB_FILE);
					$filesize = (empty($filesize)) ? 1024 : $filesize;
					if (!$fp = @fopen(DB_FILE, 'r+')) { //Öffnen der Datenbank
						echo errorOutput($GLOBALS['db_error_message']);
						break;
					}
					$fileData = fread($fp, $filesize);
					rewind($fp);
			
					$data = fgets($fp, 4096); //Liest bis zur angegebenen Länge oder einem Zeilenumbruch
					list ($counter, , , , , ) = str_replace('\|', '|', preg_split('/(?<!\\\)(\|)/', $data));
					$counter++;
					if ($counter == '') {
						$counter = 1;
					}
			
					if ($GLOBALS['notification'] == 1) {
						$title = 'Neuer Gästebucheintrag';
						
						$header = '';
						$header .= "X-Mailer: PHP/" . phpversion() . "\r\n";
						$header .= "From: PHP-Gästebuch\r\n";
						$header .= "MIME-Version: 1.0\r\n";
						$header .= "Content-Type: text/plain; charset=\"utf-8\"\r\n";
   			 			$header .= "Content-Transfer-Encoding: 7bit\r\n\r\n";
						
						$mailbody = '';
						$mailbody .= $name . ' hat in ihr Gästebuch geschrieben.' . "\r\n\r\n";
						$mailbody .= 'Hier gehts zum Eintrag: ' . GB_URL . "\r\n\r\n\r\n";
						$mailbody .= '-------' . "\r\n";
						$mailbody .= 'Name: ' . $name . "\r\n\r\n";
						$mailbody .= 'Nachricht:' . "\r\n" . $message;
					}
					
					$name = str_replace('|', '\|', $name);
					$name = str_replace("\n", '', $name);
					$message = str_replace("\r", '', $message);
					$message = str_replace("\n", '<br />', $message);
	
					$newData = $counter . '|' . $now . '|' . $sender . '|' . $ip_user . '|' . $name . '|' . $message . '|'; //Speichern des Eintrags, in das Textfeld/Datenbank
	
					rewind($fp);
					$success = fwrite($fp, $newData);
					if (!empty($fileData)) fwrite($fp, "\n" . $fileData);
					if ($GLOBALS['notification'] == 1) {
						if ($success !== FALSE) {
							@mail ($GLOBALS['email'], $title, $mailbody, $header);
						} else {
							$content = 'Ein Fehler beim Beschreiben der Textdatei ist aufgetreten!' . "\r\n" . 'Ursprüngliche Nachricht:' . "\r\n" . $mailbody;
							@mail ($GLOBALS['email'], 'Gästebuch Eintrag Fehler', $content);
						}
					}
					//E-Mail Benachrichtigung
					fclose($fp);
					
					echo '<p>Deine Nachricht wurde hinzugefügt<br /><a href="' . SELF . '#gaestebuch">Zurück zum Gästebuch</a></p>';
					break;
				}
			}
		} // Beendet die Abfrage am Anfang, ob Submit button gedrückt wurde
	
		$name = (isset($name)) ? gb_escapeStr($name) : '';
		$message = (isset($message)) ? gb_escapeStr($message) : '';
		echo '<form action="?func=message" method="POST" name="formular" id="formular" autocomplete="off"><p>
			<label for="name">Name: *</label>
			<input type="text" name="name" id="name" class="gbInput" value="' . $name . '"/><br /><br />
			
			<label for="message">Nachricht: *</label>
			' . generateBbccode($GLOBALS['folderPath'] . 'smilies.html') . '
			<textarea name="message" id="message" class="gbTextArea">' . $message . '</textarea><br />';

			if ($GLOBALS['captcha'] == 1) {
				echo '<br />
				<label for="captcha_eingabe">Bitte geben Sie folgenden Captcha-Code ein: *</label>
        		<input type="text" name="captcha_eingabe" id="captcha_eingabe" class="gbInput"> 
				<img name="Sicherheitscode" src="' . $GLOBALS['folderPath'] . 'captcha/captcha.php" alt="Captcha" style="vertical-align: middle; margin-left: 10px;" /><br />';
			}
			
			echo '
			<input type="text" name="captcha" id="captcha" class="gbInput" style="display: none;" /><br />
			<input type="submit" name="submit" class="gbBtn" value="Absenden" /><br />
			*-Pflichtfeld
		</p></form>';
	break;
	
	################
	# Adminbereich #
	################
	case 'admin':
    if (!gb_checkLogin()) { //Wenn Session nicht leer ist...
		if (isset($_SESSION[SESSION_GB_LOGIN_FAIL]) && time() > ($_SESSION[SESSION_GB_LOGIN_FAIL] + 60*60)) {
			unset($_SESSION[SESSION_GB_LOGIN_FAIL]);
		}
		if (isset($_POST['submit'])) {
			if ($_POST['submit'] === 'Einloggen' && !empty($_POST['name']) && !empty($_POST['passwort'])) { //Überprüfung des Passworts
				$name = $_POST['name'];
				$password = sha1($_POST['passwort']);
		
				//Sicherheitsprüfung gegen Brute-Force Attacken
				$ip_array = @file(IP_FILE);
				if ($ip_array === false) {
					$fp = @fopen(IP_FILE, 'w');
					fclose($fp);
					$ip_array = @file(IP_FILE);
				}
				$fp = @fopen(IP_FILE, 'w');
				$now = time();
				$amtFound = 1;
				$data = '';
				for ($i = 0; $i < count($ip_array); $i++) {
					list ($ip,$time) = explode('|', $ip_array[$i]);
					if ($now < ($time + 60*60)) {
						$data .= ($data !== '') ? "\n" . $ip . '|' . $time . '|' : '' . $ip . '|' . $time . '|';
						if ($ip === $_SERVER['REMOTE_ADDR']) {
							$amtFound++;
						}
					}
				}
				rewind($fp);
				if ($name !== ADMIN_NAME || $password !== ADMIN_PW) {
					if ($data !== '')
						$data = "\n" . $data;
					fwrite($fp, $_SERVER['REMOTE_ADDR'] . '|' . time() . '|' . $data);
				} else {
					fwrite($fp, $data);
				}
				fclose($fp);
				
				if ($amtFound >=3)
					$_SESSION[SESSION_GB_LOGIN_FAIL] = time();	
				if ($amtFound > 3) {
					echo errorOutput('Sie haben zu oft das falsche Passwort eingegeben.<br />Aus Sicherheitsgründen werden Sie für eine gewisse Zeit gesperrt!');
					break;
				}

				if ($name === ADMIN_NAME && $password === ADMIN_PW) { //Wenn beide Eingaben stimmen -> Session starten
					echo '<p>Weiterleitung...</p>';
					$_SESSION[SESSION_GB_LOGIN] = $name;
					$_SESSION[SESSION_GB_PW] = $password;
					unset($_SESSION[SESSION_GB_LOGIN_FAIL]);
					echo gb_redirect();
					break;
				}
			}
			echo errorOutput('Falsches Passwort.'); // Eingabe falsch? | Admin Menü - Passwort & Username
		}

        if (!isset($_SESSION[SESSION_GB_LOGIN_FAIL])) {
            echo '
            <form method="post" action="?func=admin"><p>

            <label for="name">Benutzername: </label>
            <input type="password" name="name" id="name" class="gbInput" /><br /><br />

            <label for="passwort">Passwort: </label>
            <input type="password" name="passwort" id="passwort" class="gbInput" /><br /><br />
            <input type="submit" name="submit" class="gbBtn" value="Einloggen" /><br />
            </p></form>'; //Formulareingabe erzeugen
        } else {
            echo errorOutput('Sie haben zu oft das falsche Passwort eingegeben.<br />Aus Sicherheitsgründen werden Sie für eine gewisse Zeit gesperrt!');
        }
		break;
	}
	
	// Edit Menü aufrufen
	if (isset($_GET['edit']) && checkInt($_GET['edit'])) {
		if (!$fp = @fopen(DB_FILE, 'r')) { //Öffnen des Textfeldes/Datenbank; @ = Unterdrückung der Fehlermeldung
			echo errorOutput($GLOBALS['db_error_message']);
			break;
		}
		$output = '';
		while (!feof($fp)) {
			$dataLine = fgets($fp, 4096); //Liest bis zur angegebenen Länge oder einem Zeilenumbruch
			
			list ($counter, $date, $sender, $ip, $name, $message) = preg_split('/(?<!\\\)(\|)/', $dataLine);
			
			if ($counter != $_GET['edit']) {
				$output .= $dataLine;
			} else {
				if (isset($_POST['submit']) && $_POST['submit'] === 'Absenden') { //Überprüfen, wenn submit Button gedrückt wird
					if (!isset($_POST['name']) || !isset($_POST['message'])) {
						echo errorOutput('Bitte alle Felder ausfüllen');
					} else {
						$name = gb_escapeStr($_POST['name']); //Eingabe des Users in eine Variable speichern
						$message = gb_escapeStr($_POST['message']);
						
						$name_len = gb_getWordLength($name); //Anzahl an Buchstaben des eingegebenen Namen
						$message_len = gb_getWordLength($message); //Anzahl an Buchstaben der eingegebenen message
						
						$error = '';
				
						if (!isset($name) || $name_len <= 0) {
							$error .= '-Bitte geben Sie einen Namen ein!<br />';
						}
				
						if (!isset($message) || $message_len <= 0) {
							$error .= '-Bitte geben Sie eine Nachricht ein!<br />';
						}
						
						if ($error) { // Ausgabe der error message
							echo errorOutput($error);
						} else {
							$name = str_replace('|', '\|', $name);
							$name = str_replace("\r", '', $name);
							$name = str_replace("\n", '', $name);
		
							$message = str_replace('|', '\|', $message);
							$message = str_replace("\r", '', $message);
							$message = str_replace("\n", '<br />', $message);
			
							$output .= $counter . '|' . $date . '|' . $sender . '|' . $ip . '|' . $name . '|' . $message . '|'; //Speichern des Eintrags, in das Textfeld/Datenbank
						
							$remainingContent = fread($fp, filesize(DB_FILE));
							$output .= ($remainingContent != '') ? "\n" . $remainingContent : '';
							fclose($fp);
		
							if (!$fp = @fopen(DB_FILE, 'w')) { //Öffnen der Datenbank
								echo errorOutput($GLOBALS['db_error_message']);
								break 2;
							}
			
							fwrite($fp, $output); //In die Datenbank schreiben | auf 0/leer setzen
							fclose($fp);
			
							//Ausgabe, wenn die Nachricht gelöscht wurde
							echo '<p>Die Nachricht wurde <b>geändert</b>.<br />
							<a href="' . SELF . '?func=admin#gaestebuch">Hier gehts zurück</a><br /></p>';
				
							break 2;
						}
					}
				}
				
				$breaks = array('<br />','<br>','<br/>');   
				$name = (isset($name)) ? gb_escapeStr($name) : '';
				$message = (isset($message)) ? gb_escapeStr(str_ireplace($breaks, "\r\n", $message)) : '';
				echo '<form action="?func=admin&amp;edit=' . $_GET['edit'] . '" method="POST" name="formular" id="formular" autocomplete="off"><p>
					<label for="name">Name: *</label>
					<input type="text" name="name" id="name" class="gbInput" value="' . $name . '"/><br /><br />
					
					<label for="message">Nachricht: *</label>
					' . generateBbccode($GLOBALS['folderPath'] . 'smilies.html') . '
					<textarea name="message" id="message" class="gbTextArea">' . $message . '</textarea><br /><br />
					
					<input type="submit" name="submit" class="gbBtn" value="Absenden" /><br />
					*-Pflichtfeld
				</p></form>';	
			}
		} //Ende while-Schleife
		fclose($fp);
	// Adminbereich - Kommentare löschen
	} elseif (isset($_GET['delete']) && checkInt($_GET['delete'])) {
		if (!$fp = @fopen(DB_FILE, 'r')) { //Öffnen des Textfeldes/Datenbank; @ = Unterdrückung der Fehlermeldung
			echo errorOutput($GLOBALS['db_error_message']);
			break;
		}
		$output = '';
		while (!feof($fp)) {
			$dataLine = fgets($fp, 4096); //Liest bis zur angegebenen Länge oder einem Zeilenumbruch
			list ($counter, $date, $sender, $ip, $name, $message) = str_replace('\|', '|', preg_split('/(?<!\\\)(\|)/', $dataLine));
			
			if ($counter != $_GET['delete']) {
				$output .= $dataLine;
			} else {
				if (isset($_GET['c']) && $_GET['c'] == 1) {
					$remainingContent = fread($fp, filesize(DB_FILE)); //Aktuelle Zeile bis zum Dateiende lesen
					fclose($fp);
					
					$output .= $remainingContent;
					if ($remainingContent == '')
						$output = substr($output, 0, -1); //Letzten Umbruch entfernen, Unbekannt wo dieser herkommt?
	
					if (!$fp = @fopen(DB_FILE, 'w')) { //Öffnen der Datenbank
						echo errorOutput($GLOBALS['db_error_message']);
						break;
					}

					fwrite($fp, $output); //In die Datenbank schreiben | auf 0/leer setzen
					fclose($fp);
		
					//Ausgabe, wenn die Nachricht gelöscht wurde
					echo '<p>Die Nachricht wurde <b>gelöscht</b>.<br />
					<a href="' . SELF . '?func=admin#gaestebuch">Hier gehts zurück</a><br /></p>';
		
					break 2;
				} else {
					if ($GLOBALS['smilies'] == 1) {
						$message = replaceSmilie($message);
					}
					if ($GLOBALS['bbccode'] == 1) {
						$message = replaceBbccode($message);
					}
		
					$dayArray = array('Sonntag', 'Montag', 'Dienstag', 'Mittwoch', 'Donnerstag', 'Freitag', 'Samstag');
					$dayNumber = date("w", $date); // Aktuellen Tag ermitteln
					$day = $dayArray[$dayNumber]; //Wochentag ermitteln
		
					echo '<p>Sind Sie sicher, dass diese Nachricht gelöscht werden soll?</p><br />';
					if ($sender === 'a') {
						echo '<p style="color: ' . $GLOBALS['color'] . '; display: inline;"> ' . $name . '<br /></p>
						<p>(' . $day . ', ' . date($GLOBALS['dateformat'], $date) . ')<br />' . $message . '</p>';
					} elseif ($sender === 'b') {
						echo '<p style="display: inline;"> <b>' . $name . '</b><br /></p>
						<p>(' . $day . ', ' . date($GLOBALS['dateformat'], $date) . ')<br />' . $message . '</p>';
					}
				
					echo '<br /><p><a href="' . SELF . '?func=admin&amp;delete=' . $counter . '&amp;c=1#gaestebuch"><u>Ja</u></a> -
					<a href="' . SELF . '?func=admin#gaestebuch">Nein</a></p>'; //Wenn Admin löschen gedrückt hat ...
					break 2;	
				}
			}
		}
		fclose($fp);
		
		echo errorOutput('Fehler beim Löschen dieses Beitrags.<br /><a href="' . SELF . '?func=admin#gaestebuch">Hier gehts zurück</a>');
	// Adminbereich - Kommentare mit Edit/Delete Funktionen ausgeben
	} else {
		$gb_size = filesize(DB_FILE);
		$gb_entries = count(file(DB_FILE));
		echo '
		<p>~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~<br />
		~ Einträge: ' . $gb_entries . ' - Dateigröße: ' . round($gb_size / 1024, 1) . 'KB - Version: ' . $GLOBALS['gb_version'] . '<br />
		~<br />
		~ Created by Dennis --> <a href="http://suchdichsatt.de/" target="_blank">suchdichsatt.de</a><br />	
		~<br />~ ';
		
		$check_version = fopen('http://suchdichsatt.de/scripte/gaestebuch/gaestebuch_version.txt', 'r');
		$data = fgets($check_version, 4096);
		list ($current_version, $current_name) = explode('|', $data);
		fclose($check_version);

		if ($GLOBALS['gb_version'] < $current_version) {
			echo ' 
			<img src="http://www.suchdichsatt.de/bilder/kreuz.png" alt="Kreuz" style="height: 10px; width: 15px; vertical-align: middle;" />
			Es ist eine neuere Gästebuch Version verfügbar:<br />
			~ <img src="http://www.suchdichsatt.de/bilder/kreuz.png" alt="Kreuz" style="height: 10px; width: 15px; vertical-align: middle;" />
			<a href="http://suchdichsatt.de/tutorials/php_gaestebuch.php" target="_blank">' . $current_name . '</a>';
		} elseif ($GLOBALS['gb_version'] == $current_version || $GLOBALS['gb_version'] > $current_version) {
			echo '
			<img src="http://www.suchdichsatt.de/bilder/haken.png" alt="Haken" style="height: 15px; width: 15px; vertical-align: middle;" />
			Aktuelle Version';
		} else {
			echo '<img src="http://www.suchdichsatt.de/bilder/kreuz.png" alt="Kreuz" style="height: 10px; width: 15px; vertical-align: middle;" />
			Versionscheck nicht möglich!';
		}
		echo '<br />~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~</p><br />';

	
		if (!$fp = @fopen(DB_FILE, 'r')) { //Öffnen des Textfeldes/Datenbank; @ = Unterdrückung der Fehlermeldung
			echo errorOutput($GLOBALS['db_error_message']);
			break;
		}

		$i = count(file(DB_FILE));;
		while (!feof($fp)) { //Prüft ob der Dateizeiger am Ende der Datei angekommen ist
			$data = fgets($fp, 4096); //Liest bis zur angegebenen Länge oder einem Zeilenumbruch
			if (empty($data)) break;
			list ($counter, $date, $sender, $ip, $name, $message) = str_replace('\|', '|', preg_split('/(?<!\\\)(\|)/', $data));
			
			if ($GLOBALS['smilies'] == 1) {
				$message = replaceSmilie($message);
			}
			if ($GLOBALS['bbccode'] == 1) {
				$message = replaceBbccode($message);
			}

			$dayArray = array('Sonntag', 'Montag', 'Dienstag', 'Mittwoch', 'Donnerstag', 'Freitag', 'Samstag');
			$dayNumber = date("w", $date); // Aktuellen Tag ermitteln
			$day = $dayArray[$dayNumber]; //Wochentag ermitteln

			echo '
			<p class="small">
				<a href="' . SELF . '?func=admin&edit=' . $counter . '#gaestebuch">[ändern]</a>
				<a href="' . SELF . '?func=admin&delete=' . $counter . '#gaestebuch">[löschen]</a>
				<a href="http://whois.sc/' . $ip . '" target="_blank">[IP ansehen]</a>
			</p>';
			if ($sender === 'a') {
				echo '<p style="color: ' . $GLOBALS['color'] . '; display: inline;"> ' . $name . ' <span style="float: right;">#' . $i . '</span><br /></p>
				<p>(' . $day . ', ' . date($GLOBALS['dateformat'], $date) . ')<br />' . $message . '<br /><br />
				' . gb_getLayout('hr') . '</p>';
			} elseif ($sender === 'b') {
				echo '<p style="display: inline;"> <b>' . $name . '</b> <span style="float: right;">#' . $i . '</span><br /></p>
				<p>(' . $day . ', ' . date($GLOBALS['dateformat'], $date) . ')<br />' . $message . '<br /><br />
				' . gb_getLayout('hr') . '</p>';
			}
			$i--;
		}
		fclose($fp);
	}
	break;
	
	##########
	# Config #
	##########
	case 'config':
	if (gb_checkLogin()) { //Wenn Session nicht leer ist...
		$output = '';
		$output .= '
		<form action="' . SELF . '?func=config" method="POST">
			<div id="config">
				<p>
				<label for="colorpickerField1">Admin- & Meldungsfarbe:</label>
				<input type="text" class="gbInput" maxlength="6" name="color" id="colorpickerField1" value="' . substr($GLOBALS['color'],1) . '" /><br /><br />

				<label for="post_time">Zeitsperre nach einem Beitrag:</label>
				<input type="text" class="gbInput" name="post_time" id="post_time" value="' . $GLOBALS['post_time'] . '" /> Sekunden<br /><br />
				
				<label for="dateformat">Datumsformat:</label>
				<input type="text" class="gbInput" name="dateformat" id="dateformat" value="' . $GLOBALS['dateformat'] . '" /> 
				<a href="http://php.net/manual/de/function.date.php" target="_blank">&raquo; Zeichen Tabelle</a><br /><br />
				
				<label>E-Mail Adresse:</label>
				<input type="text" class="gbInputBig" name="email" value="' . $GLOBALS['email'] . '" /><br /><br />
				
				<label>Email Benachrichtigung pro Beitrag:</label>
				<input type="radio" name="notification" id="notificationOn"';
		$output .= ($GLOBALS['notification'] == 1) ? ' checked="checked"': '';
		$output .= ' value="1"> <label for="notificationOn" class="gbLabelSmall">An</label>
				<input type="radio" name="notification" id="notificationOff"';
		$output .= ($GLOBALS['notification'] == 0) ? ' checked="checked"': '';
		$output .= ' value="0"> <label for="notificationOff" class="gbLabelSmall">Aus</label><br /><br />
				
				<label>Bbccode verwenden:</label>
				<input type="radio" name="bbccode" id="bbccodeOn"';
		$output .= ($GLOBALS['bbccode'] == 1) ? ' checked="checked"': '';
		$output .= ' value="1"> <label for="bbccodeOn" class="gbLabelSmall">An</label>
				<input type="radio" name="bbccode" id="bbccodeOff"';
		$output .= ($GLOBALS['bbccode'] == 0) ? ' checked="checked"': '';
		$output .= ' value="0"> <label for="bbccodeOff" class="gbLabelSmall">Aus</label><br /><br />
		
				<label>Smilies verwenden:</label>
				<input type="radio" name="smilies" id="smiliesOn"';
		$output .= ($GLOBALS['smilies'] == 1) ? ' checked="checked"': '';
		$output .= ' value="1"> <label for="smiliesOn" class="gbLabelSmall">An</label>
				<input type="radio" name="smilies" id="smiliesOff"';
		$output .= ($GLOBALS['smilies'] == 0) ? ' checked="checked"': '';
		$output .= ' value="0"> <label for="smiliesOff" class="gbLabelSmall">Aus</label><br /><br />
				
				<label>Captcha verwenden:</label>
				<input type="radio" name="captcha" id="captchaOn"';
		$output .= ($GLOBALS['captcha'] == 1) ? ' checked="checked"': '';
		$output .= ' value="1"> <label for="captchaOn" class="gbLabelSmall">An</label>
				<input type="radio" name="captcha" id="captchaOff"';
		$output .= ($GLOBALS['captcha'] == 0) ? ' checked="checked"': '';
		$output .= ' value="0"> <label for="captchaOff" class="gbLabelSmall">Aus</label><br /><br />

				<label>Badword Filter:</label>
				<input type="radio" name="badword_filter" id="badword_filterOn"';
		$output .= ($GLOBALS['badword_filter'] == 1) ? ' checked="checked"': '';
		$output .= ' value="1"> <label for="badword_filterOn" class="gbLabelSmall">An</label>
				<input type="radio" name="badword_filter" id="badword_filterOff"';
		$output .= ($GLOBALS['badword_filter'] == 0) ? ' checked="checked"': '';
		$output .= ' value="0"> <label for="badword_filterOff" class="gbLabelSmall">Aus</label><br /><br />
				
				<label for="badwords">Badwords:</label>
				<textarea name="badwords" id="badwords" class="gbTextArea">' . $GLOBALS['badwords_string'] . '</textarea><br /><br />
				
				<label for="min_name">Minimale Namen-Länge:</label>
				<input type="text" class="gbInput" name="min_name" id="min_name" value="' . $GLOBALS['min_name'] . '" /><br /><br />
				
				<label for="max_name">Maximale Namen-Länge:</label>
				<input type="text" class="gbInput" name="max_name" id="max_name" value="' . $GLOBALS['max_name'] . '" /><br /><br />
				
				<label for="min_message">Minimale Nachricht-Länge:</label>
				<input type="text" class="gbInput" name="min_message" id="min_message" value="' . $GLOBALS['min_message'] . '" /><br /><br />
				
				<label for="max_message">Maximale Nachricht-Länge:</label>
				<input type="text" class="gbInput" name="max_message" id="max_message" value="' . $GLOBALS['max_message'] . '" /><br /><br />
				
				<label for="max_url">URLs zulässig:</label>
				<select name="max_url" id="max_url" class="gbSelect">';
		for ($i = -1; $i<=10; $i++) {
			$checked = ($GLOBALS['max_url'] == $i) ? ' selected="selected"' : '';
			$output .= '<option value="' . $i. '"' . $checked . '>' . $i . '</option>';
		}		
		$output .= '
				</select><br /><br />
				
				<label for="ip_ban_message">Ip Speere Fehlermeldung:</label>
				<input type="text" class="gbInputHuge" name="ip_ban_message" id="ip_ban_message" value="' . $GLOBALS['ip_ban_message'] . '" /><br /><br />
				
				<label for="db_error_message">Ip Speere Fehlermeldung</label>
				<input type="text" class="gbInputHuge" name="db_error_message" id="db_error_message" value="' . $GLOBALS['db_error_message'] . '" /><br /><br />
				
				<input type="submit" name="submit" class="gbBtn" value="Speichern" /><br />
				</p>
			</div></form>';
		echo $output;
	} else {
		echo 'Nicht eingeloggt!';	
	}
	break;
}
echo '</div>';
?>